var bizagiUtil = require('bz-util');
var REQUIRED = bizagiUtil.REQUIRED;
var ERROR = bizagiUtil.error;
var RESPONSE = bizagiUtil.getResponse;
 
/**
 * @author luis.avila@bizagi.com
 */ 

function invoke(globals, actionName, data, authenticationType, LOG, callback) {
    var Client = REQUIRED('node-rest-client').Client;
var client = new Client();

if(data.inputs.input.columns && data.inputs.input.columns.length > 0){
    data.inputs.input.columns[0].primary = true;
    for (var i = 0; i < data.inputs.input.columns.length; i++) {
        data.inputs.input.columns[i].type = "TEXT_NUMBER";
    }
}

// set content-type header and data as json in args parameter
var args = {
    data: data.inputs.input,
    headers: {
        "Authorization": "Bearer " + globals.authdata.TOKEN,
        "Content-Type": "application/json"
    }
};

client.post("https://api.smartsheet.com/2.0/sheets", args, function (data, response) {
    if(data && data.result){
        var success = RESPONSE(data.result, null, 200);
        callback(success);
    } else {
        var error = RESPONSE(null, data.message, 400, data.message);
        callback(error);
    }
});
}

exports.invoke = invoke;